//redFrik 2013-10-02

//edit the file ~/Documents/Arduino/libraries/Tlc5940/tlc_config.h and set NUM_TLCS to 2
//set board "Arduino NG or older w/ ATmega168", serial port and stk500v2 programmer
//burn bootloader (to set correct fuses) and last upload using programmer

//protocol:
//254 ch0_HI ch0_LO ch1_HI ch1_LO ... 255

#include "Tlc5940.h"

#define NUM NUM_TLCS*32
#define NUM2 NUM/2

byte data[NUM];
byte index= 0;
byte val;
byte cnt= 0;

void setup() {
  pinMode(6, OUTPUT);        //status led
  pinMode(8, INPUT_PULLUP);  //off button
  Serial.begin(115200);
  Tlc.init();
  delay(1);                  //needed
  clearAllLeds();
  for(byte i= 0; i<NUM; i++) {
    data[i]= 0;
    PORTD |= _BV(DDD6);  //pd6 high
    delay(10);
    PORTD &= ~_BV(DDD6);  //pd6 low
    delay(30);
  }
}
void loop() {
  if(digitalRead(8)==LOW) {
    Serial.println("stop");
    clearAllLeds();
    PORTD &= ~_BV(DDD6);  //pd6 low
    cnt= 0;
    index= 0;
    delay(1000);
    Serial.flush();
  }
  while(Serial.available()) {
    val= Serial.read();
    if(index==0) {
      if(val==254) {
        index= 1;
      }
    } 
    else {
      if(index>NUM) {
        if(val==255) {
          if(cnt++%2==0) {
            PORTD |= _BV(DDD6);  //pd6 high
          } 
          else {
            PORTD &= ~_BV(DDD6);  //pd6 low
          }
          for(byte i= 0; i<NUM2; i++) {
            Tlc.set(i, 4095-((data[i*2]<<8)+data[i*2+1]));  //inverted because of uln2803
          }
          Tlc.update();
        }
        index= 0;
      } 
      else {
        data[index-1]= val;
        index++;
      }
    }
  }
}
void clearAllLeds() {
  for(byte i= 0; i<NUM2; i++) {
    Tlc.set(i, 4095);  //inverted because of uln2803
  }
  Tlc.update();
}

